/*
 * ProjectAssistant
 *
 *  Created on: 27.03.2010
 *
 *      Author: emanoil aka deloptes
 *
 * This code is a simple example on how to use the Assistant class.
 *
 * The demo has 4 pages
 *
 *  - project setup (introduction) page 
 *
 *  - file setup page
 *
 *  - confirmation page
 *
 *  - summary page
 *
 */

#include "example_project_assistant.h"
//can be used to call it from external app
ProjectAssistant* doProjectAssistant() {
	return new ProjectAssistant();
}
/** Constructor
  *  - initialize width, hight and name
  */

ProjectAssistant::ProjectAssistant() :
m_width(480),
m_height(320),
m_name("ProjectAssistant (Example)"),
m_Button2("Directory"),
m_Label1("Project Name"),
m_Label2("Project Version"),
m_Label4("File Name"),
m_Label5("File Version"),
m_Label6("File Location"),
m_TablePage1(2, 2, false),
m_TablePage2(3, 3, false),
m_TablePage3(1, 6, false)
{
	// TODO Auto-generated constructor stub
	initAttributes();
}

/** Destructor
  *  - remove all pages
  */
ProjectAssistant::~ProjectAssistant() {
	// TODO Auto-generated destructor stub
	list<Widget*>::iterator iter = m_pages.begin();

	while (iter != m_pages.end()) {
		delete *iter;
		iter++;
	}
}

// Private attribute accessor methods
//


/**
 * Set the value of m_width
 * @param new_var the new value of m_width
 */
void ProjectAssistant::setWidth ( unsigned int new_var ) {
  m_width = new_var;
}

/**
 * Get the value of m_width
 * @return the value of m_width
 */
unsigned int ProjectAssistant::getWidth ( ) {
  return m_width;
}

/**
 * Set the value of m_height
 * @param new_var the new value of m_height
 */
void ProjectAssistant::setHeight ( unsigned int new_var ) {
  m_height = new_var;
}

/**
 * Get the value of m_height
 * @return the value of m_height
 */
unsigned int ProjectAssistant::getHeight ( ) {
  return m_height;
}

// Other methods
//

/**
 * Get the value of m_name
 * @return the value of m_name
 */
Glib::ustring ProjectAssistant::get_AssisstantName ( ) {
  return m_name;
}

/**
 * Initializes all attributes
 * and builds the ProjectAssistant together
 */
void ProjectAssistant::initAttributes() {

    set_title( get_AssisstantName() );
    set_default_size( getWidth(), getHeight() );

    signal_cancel().connect(sigc::mem_fun(*this, &ProjectAssistant::on_cancel_clicked));
    signal_close().connect(sigc::mem_fun(*this, &ProjectAssistant::on_cancel_clicked));
    signal_apply().connect(sigc::mem_fun(*this, &ProjectAssistant::on_apply_clicked));

    p_VBoxPage1 = new Gtk::VBox;
    p_VBoxPage2 = new Gtk::VBox;
    p_VBoxPage3 = new Gtk::VBox;
    p_VBoxPage4 = new Gtk::VBox;

    m_TablePage1.attach(m_Label1, 0, 1, 0, 1);
    m_TablePage1.attach(m_Entry1, 1, 2, 0, 1);
    m_TablePage1.attach(m_Label2, 0, 1, 1, 2);
    m_TablePage1.attach(m_Entry2, 1, 2, 1, 2);

    m_TablePage2.attach(m_Label4, 0, 1, 0, 1);
    m_TablePage2.attach(m_Entry4, 1, 2, 0, 1);
    m_TablePage2.attach(m_Label5, 0, 1, 1, 2);
    m_TablePage2.attach(m_Entry5, 1, 2, 1, 2);
    m_TablePage2.attach(m_Label6, 0, 1, 2, 3);
    m_TablePage2.attach(m_Entry6, 1, 2, 2, 3);
    m_TablePage2.attach(m_Button2, 2, 3, 2, 3);

    m_TablePage3.attach(m_Label7 , 0, 1, 0, 1);
    m_TablePage3.attach(m_Label10, 0, 1, 1, 2);
    m_TablePage3.attach(m_Label8 , 0, 1, 2, 3);
    m_TablePage3.attach(m_Label11, 0, 1, 3, 4);
    m_TablePage3.attach(m_Label12, 0, 1, 5, 6);

    p_VBoxPage1->pack_end(m_TablePage1);
    p_VBoxPage2->pack_end(m_TablePage2);
    p_VBoxPage3->pack_end(m_TablePage3);
    p_VBoxPage4->pack_end(m_Summary);


    append_page(*p_VBoxPage1); m_pages.push_back(p_VBoxPage1);
    append_page(*p_VBoxPage2); m_pages.push_back(p_VBoxPage2);
    append_page(*p_VBoxPage3); m_pages.push_back(p_VBoxPage3);
    append_page(*p_VBoxPage4); m_pages.push_back(p_VBoxPage4);

    set_page_type (*p_VBoxPage1, Gtk::ASSISTANT_PAGE_INTRO);
    set_page_title(*p_VBoxPage1, "Project setup");
    set_page_type (*p_VBoxPage2, Gtk::ASSISTANT_PAGE_CONTENT);
    set_page_title(*p_VBoxPage2, "File setup");
    set_page_type (*p_VBoxPage3, Gtk::ASSISTANT_PAGE_CONFIRM);
    set_page_title(*p_VBoxPage3, "Create Project");
    set_page_type (*p_VBoxPage4, Gtk::ASSISTANT_PAGE_SUMMARY);
    set_page_title(*p_VBoxPage4, "Summary");

    // default values
    m_Entry1.set_text("New Project");
    m_Entry2.set_text("0.1");
    m_Entry4.set_text("New File");
    m_Entry5.set_text("0.1");
    m_Entry6.set_text("New Folder");

    set_page_complete(*p_VBoxPage1,true);
    set_page_complete(*p_VBoxPage2,true);
    set_page_complete(*p_VBoxPage3,true);
    update_summary();
    set_page_complete(*p_VBoxPage4,true);

    m_Button2.signal_clicked().connect(
                sigc::mem_fun(*this, &ProjectAssistant::on_Button2_clicked));

    m_Entry1.signal_changed().connect(sigc::mem_fun(*this,
    				&ProjectAssistant::on_entry1_changed));
    m_Entry2.signal_changed().connect(sigc::mem_fun(*this,
    				&ProjectAssistant::on_entry2_changed));
    m_Entry4.signal_changed().connect(sigc::mem_fun(*this,
    				&ProjectAssistant::on_entry4_changed));
    m_Entry5.signal_changed().connect(sigc::mem_fun(*this,
    				&ProjectAssistant::on_entry5_changed));
    m_Entry6.signal_changed().connect(sigc::mem_fun(*this,
    				&ProjectAssistant::on_entry6_changed));

    show_all();

}

// Other methods

Glib::ustring ProjectAssistant::get_ProjectName()
{
	return m_ProjectName;
}

Glib::ustring ProjectAssistant::get_ProjectVersion() 
{
	return m_ProjectVersion;
}

Glib::ustring ProjectAssistant::get_FileName() 
{
	return m_FileName;
}

Glib::ustring ProjectAssistant::get_FileVersion() 
{
	return m_FileVersion;
}

Glib::ustring ProjectAssistant::get_FileLocation() 
{
	return m_FileLocation;
}

void ProjectAssistant::set_ProjectName(string new_var)
{
	m_ProjectName= (Glib::ustring)  new_var ;
	m_Entry1.set_text(m_ProjectName);
}

void ProjectAssistant::set_ProjectVersion(string str)
{
	m_ProjectVersion =(Glib::ustring) str;
	m_Entry2.set_text( m_ProjectVersion);
}

void 
ProjectAssistant::set_FileName(string new_var)
{
	m_FileName = (Glib::ustring) new_var;
	m_Entry4.set_text( m_FileName );
}

void 
ProjectAssistant::set_FileVersion(string new_var)
{
	m_FileVersion = (Glib::ustring) new_var;
	m_Entry5.set_text( m_FileVersion );
}

void 
ProjectAssistant::set_FileLocation(string new_var)
{
	m_FileLocation = (Glib::ustring) new_var;
	m_Entry6.set_text(m_FileLocation);
}

// project name
void 
ProjectAssistant::on_entry1_changed() {
	set_ProjectName(m_Entry1.get_text());
	update_summary();
	if ( m_Entry2.get_text() != "" )
		set_page_complete(*p_VBoxPage1, true);
}

// project version
void 
ProjectAssistant::on_entry2_changed() {
	set_ProjectVersion(m_Entry2.get_text());
	update_summary();
	if ( m_Entry1.get_text() != "" )
		set_page_complete(*p_VBoxPage1, true);
}

// File name
void 
ProjectAssistant::on_entry4_changed() {
	set_FileName(m_Entry4.get_text());
	update_summary();
	if ( m_Entry5.get_text() != "" &&  m_Entry6.get_text() != "" ) {
		set_page_complete(*p_VBoxPage2, true);
		set_page_complete(*p_VBoxPage3, true);
	}
}

// File version
void 
ProjectAssistant::on_entry5_changed() {
	set_FileVersion(m_Entry5.get_text());
	update_summary();
	if ( m_Entry4.get_text() != "" &&  m_Entry6.get_text() != "" ) {
		set_page_complete(*p_VBoxPage2, true);
		set_page_complete(*p_VBoxPage3, true);
	}
}

// File location
void 
ProjectAssistant::on_entry6_changed() {
	set_FileLocation(m_Entry6.get_text());
	update_summary();
	if ( m_Entry4.get_text() != "" &&  m_Entry5.get_text() != "" ) {
		set_page_complete(*p_VBoxPage2, true);
		set_page_complete(*p_VBoxPage3, true);
	}
}


void
ProjectAssistant::on_Button2_clicked() {
	Gtk::FileChooserDialog dialog("Please choose a folder",
			Gtk::FILE_CHOOSER_ACTION_SELECT_FOLDER);
	dialog.set_transient_for(*this);

	//Add response buttons the the dialog:
	dialog.add_button(Gtk::Stock::CANCEL, Gtk::RESPONSE_CANCEL);
	dialog.add_button("Select", Gtk::RESPONSE_OK);

	int theResult = dialog.run();

	//Handle the response:
	switch (theResult) {
	case (Gtk::RESPONSE_OK): {
		set_FileLocation(dialog.get_uri());
	}
	case (Gtk::RESPONSE_CANCEL): {
		break;
	}
	default: {
		break;
	}
	}
}

void 
ProjectAssistant::on_apply_clicked(void) {

	cout << "LOADED SUCCESSFULLY" << endl;
	set_page_complete(*p_VBoxPage4, true);
	m_Summary.set_text("The Project has been\ncreated successfully!");

}

void
ProjectAssistant::on_cancel_clicked(void) {
       hide();
}


void
ProjectAssistant::update_summary(void) {
    m_Label7.set_text (m_Label1.get_text() + ":\t" + m_Entry1.get_text());
    m_Label8.set_text (m_Label2.get_text() + ":\t" + m_Entry2.get_text());
    m_Label10.set_text(m_Label4.get_text() + ":\t" + m_Entry4.get_text());
    m_Label11.set_text(m_Label5.get_text() + ":\t" + m_Entry5.get_text());
    m_Label12.set_text(m_Label6.get_text() + ":\t" + m_Entry6.get_text());
}
