/*
 * ProjectAssistant
 *
 *  Created on: 27.03.2010
 *      Author: emanoil aka deloptes
 *
 * This code is a simple example on how to use the Assistant class.
 *
 * The demo has 4 pages
 *  - project setup (introduction) page 
 *  - file setup page
 *  - confirmation page
 *  - summary page
 *
 * The forward button on each page is activated after testing for
 * non empty fields.
 *
 */

#ifndef PROJECTASSISTANT_H_
#define PROJECTASSISTANT_H_

#include <iostream>
#include <list>
#include <gtkmm.h>

using namespace std;
/**
 * class ProjectAssistant
 */

class ProjectAssistant: public Gtk::Assistant {
public:
	ProjectAssistant();
	virtual ~ProjectAssistant();
	// Private attribute accessor methods
	//

	/**
	 * Set the value of m_width
	 * @param new_var the new value of m_width
	 */
	void setWidth(unsigned int new_var);

	/**
	 * Get the value of m_width
	 * @return the value of m_width
	 */
	unsigned int getWidth();

	/**
	 * Set the value of m_height
	 * @param new_var the new value of m_height
	 */
	void setHeight(unsigned int new_var);

	/**
	 * Get the value of m_height
	 * @return the value of m_height
	 */
	unsigned int getHeight();

	/**
	 */
	virtual void set_ProjectName(string );
	/**
	 */
	Glib::ustring get_ProjectName();
	/**
	 */
	virtual void set_ProjectVersion(string );
	/**
	 */
	Glib::ustring get_ProjectVersion() ;
	/**
	 */
	virtual void set_FileName(string );
	/**
	 */
	Glib::ustring get_FileName() ;
	/**
	 */
	virtual void set_FileVersion(string );
	/**
	 */
	Glib::ustring get_FileVersion() ;
	/**
	 */
	virtual void set_FileLocation(string );
	/**
	 */
	Glib::ustring get_FileLocation() ;
	/**
	 */
	Glib::ustring get_AssisstantName() ;


private:
	/**
	 */
	virtual void initAttributes();
	/**
	 */
	virtual void on_entry1_changed();
	/**
	 */
	virtual void on_entry2_changed();
	/**
	 */
	virtual void on_entry4_changed();
	/**
	 */
	virtual void on_entry5_changed();
	/**
	 */
	virtual void on_entry6_changed();
	/**
	 */
	virtual void on_Button2_clicked();


	// Private attributes
	//

	unsigned int m_width;
	unsigned int m_height;
	Glib::ustring m_name;

protected:
	// store the pages in a list so we can delete them later
	list<Gtk::Widget*> m_pages;
	Gtk::VBox *p_VBoxPage1, *p_VBoxPage2, *p_VBoxPage3, *p_VBoxPage4;

	Gtk::Button m_Button2;

	Gtk::Label m_Label1, m_Label2, m_Label4, m_Label5,
			   m_Label6, m_Label7, m_Label8, m_Label10,
			   m_Label11, m_Label12, m_Summary;

	Gtk::Table m_TablePage1, m_TablePage2, m_TablePage3;

	Gtk::Entry m_Entry1, m_Entry2, m_Entry4, m_Entry5, m_Entry6;

	Glib::ustring  m_ProjectName, m_ProjectVersion,
		m_FileName, m_FileVersion, m_FileLocation;

	/**
	 */
	virtual void on_cancel_clicked(void);
	/**
	 */
	virtual void on_apply_clicked(void);
	/**
	 */
	virtual void update_summary(void);
};

#endif /* PROJECTASSISTANT_H_ */
